
#===========> Input File


proc PrgInputFile {numproj w wlog wstatus} {
# set up needed widgets in frame w for file selection in Fdat directories

	global Obj_Proj Obj_Dir
	set path $Obj_Dir(Proj)/$Obj_Proj($numproj)/Fdat

	# Filter for File Selection
	frame $w.filter -bd 2 -relief ridge

	label $w.filter.name -text "Filter :" -width 6 -anchor w
	entry $w.filter.value -width 10

	bind $w.filter.value <Return> [list Fdat_SetMenu $w.but.mb {Fdat/} $w.filter.value $w.ent $wlog $wstatus $path]

	pack $w.filter.name -side left
	pack $w.filter.value -side left -expand true -fill x

	$w.filter.value insert end {*.*}

	# Entry for Selected File

	entry $w.ent
	bind $w.ent <Return> [list Fdat_CheckFile $w.ent]

	# Frame for buttons
	frame $w.but

	# Button for Clean up
	button $w.but.clear -text "Clear" -command [list Fdat_Clear "$w.ent $w.filter.value"]

	update
	show-status "Wait Please ! : Scanning Fdat" $wstatus

	# MenuButton for File Selection
	Fdat_SetMenu $w.but.mb {Fdat/} $w.filter.value $w.ent $wlog $wstatus $path
	$wlog delete 1.0 end

	pack $w.but.clear $w.but.mb -side left

	# Pack main frames
	pack $w.filter $w.ent $w.but -side top

	show-status "Ready ..." $wstatus
	return $w.ent
}
proc Fdat_SetMenu {mb title wprompt wentry wlog wstatus path} {

	catch {destroy $mb}
	$wentry delete 0 end

	set m  $mb.menu
	menubutton $mb -text $title -menu $m \
		-relief raised \
		-underline 0 -disabledforeground {}
	pack $mb -padx 5 -pady 5 

	$mb configure -state disabled
	update idletasks
	CascadeMenuDir $path 1 $m [$wprompt get] $wentry $wlog $wstatus
	$mb configure -state normal
	show-status "Ready ..." $wstatus
}
proc Fdat_CheckFile {wentry} {

	Fdat_UpdateEntryChoice $wentry
	set file [$wentry get]
	if ![ file exists $file ] {
        	tk_dialog $wentry.d {TkfPW Error} "File $file" error 0 {Try Again !}
		$wentry delete 0 end
	}
}

proc Fdat_Clear {w} {
	foreach widget $w {
		catch { $widget delete 0 end }
	}
}
proc Fdat_GetFileFromMenu {file wentry} {

PRINT "Select $file"
#	regsub ^$path/ $file {} fdat_file
	$wentry delete 0 end
	$wentry insert end $file
	Fdat_UpdateEntryChoice $wentry
}

proc Fdat_UpdateEntryChoice {wentry} {
	$wentry xview end
	$wentry icursor end
}

#===========> Output File

proc PrgOutputFile {numproj w wlog wstatus} {
# set up needed widgets in frame w for file selection in Fres directories

	global Obj_Proj Obj_Dir
	set path $Obj_Dir(Proj)/$Obj_Proj($numproj)/Fres

	# Filter for File Selection
	frame $w.filter -bd 2 -relief ridge

	label $w.filter.name -text "Filter :" -width 6 -anchor w
	entry $w.filter.value -width 10

	bind $w.filter.value <Return> [list Fres_SetMenu $w.but.mb {Fres/} $w.filter.value $w.ent $wlog $wstatus $path]

	pack $w.filter.name -side left
	pack $w.filter.value -side left -expand true -fill x

	$w.filter.value insert end {*.*}

	# Entry for Selected File

	entry $w.ent
	bind $w.ent <Return> [list Fres_CheckFile $w.ent]

	# Frame for buttons
	frame $w.but

	# Button for Clean up
	button $w.but.clear -text "Clear" -command [list Fres_Clear "$w.ent $w.filter.value"]

	update
	show-status "Wait Please ! : Scanning Fres" $wstatus

	# MenuButton for File Selection
	Fres_SetMenu $w.but.mb {Fres/} $w.filter.value $w.ent $wlog $wstatus $path
	$wlog delete 1.0 end

	pack $w.but.clear $w.but.mb -side left

	# Pack main frames
	pack $w.filter $w.ent $w.but -side top

	show-status "Ready ..." $wstatus
	return $w.ent
}
proc Fres_SetMenu {mb title wprompt wentry wlog wstatus path} {

	catch {destroy $mb}
	$wentry delete 0 end

	set m  $mb.menu
	menubutton $mb -text $title -menu $m \
		-relief raised \
		-underline 0 -disabledforeground {}
	pack $mb -padx 5 -pady 5 

	$mb configure -state disabled
	update idletasks
	CascadeMenuDir $path 1 $m [$wprompt get] $wentry $wlog $wstatus
	$mb configure -state normal
	show-status "Ready ..." $wstatus
}
proc Fres_CheckFile {wentry} {

	Fres_UpdateEntryChoice $wentry
	set file [$wentry get]
	set dir [file dirname $file]
	if ![ file isdirectory $dir ] {
        	tk_dialog $wentry.d {TkfPW Error} "Directory $dir doesn't exist" error 0 {Try Again !}
		$wentry delete 0 end
	}
}

proc Fres_Clear {w} {
	foreach widget $w {
		catch { $widget delete 0 end }
	}
}
proc Fres_GetFileFromMenu {file wentry} {

PRINT "Select $file"
#	regsub ^$path/ $file {} Fres_file
	$wentry delete 0 end
	$wentry insert end $file
	Fres_UpdateEntryChoice $wentry
}

proc Fres_UpdateEntryChoice {wentry} {
	$wentry xview end
	$wentry icursor end
}


#===========> Common


proc CascadeMenuDir {Dir ndir m filter wentry wlog wstatus} {

	menu $m -tearoff 0
	$m add command -label "Directory [file tail $Dir]"
	$m add separator

	if { $ndir == 1 } {$wlog delete 1.0 end}

	# Scan the Dir
	set list_dir {} ; set list_file {}
	foreach file [ lsort -ascii [glob  -nocomplain -- $Dir/*] ] {
		if [file isdirectory $file] {
			show-status "Wait Please ! : Scanning ...$ndir" $wstatus
			lappend list_dir $file
		} else {
			lappend list_file $file
		}
	}

	# Cascade Menu for Directories in Dir
	foreach dir $list_dir {
		incr ndir
		$m add cascade -label "[file tail $dir]" -menu $m.$ndir -underline 0
		# Recursive set up !!!
		CascadeMenuDir $dir $ndir $m.$ndir $filter $wentry $wlog $wstatus
	}

	# Menu for Files of Dir
	if { $filter != {} } {
		set list_file [ExtractInList $list_file $filter]
		foreach file  $list_file {
			$wlog insert end $file\n
		}
	}
	foreach file $list_file {
		$m add command -label [file tail $file] -command [list Fres_GetFileFromMenu $file $wentry]
	}
		$m add command -label {Select Directory !} -command [list Fres_GetFileFromMenu $Dir/ $wentry]

}
